#
# Hack to map some email addrs to a default employer
#

#
# This code is part of the LWN git data miner.
#
# Copyright 2007 LWN.net
# Copyright 2007 Jonathan Corbet <corbet@lwn.net>
#
# This file may be distributed under the terms of the GNU General
# Public License, version 2.
#

import PrivateMap


EmailToEmployer = {
    #
    # Known individual addresses.
    #
    'mingo@elte.hu': 'Red Hat',
    'alan@lxorguk.ukuu.org.uk': 'Red Hat', # Cox
    'linville@tuxdriver.com': 'Red Hat',
    'arjan@infradead.org': 'Intel',
    'jra@samba.org': 'Google',
    'rustcorp.com.au': 'IBM',  # Rusty
    'akpm@linux-foundation.org': 'Google',


    '8d.com': '8D Technologies',
    'adaptec.com': 'Adaptec',
    'amd.com': 'AMD',
    'arm.com': 'ARM',
    'atmel.com': 'Atmel',
    'baslerweb.com': 'Basler Vision Technologies',
    'broadcom.com': 'Broadcom',
    'brontes3d.com': 'Brontes Technologies',
    'chelsio.com': 'Chelsio',
    'cisco.com': 'Cisco',
    'clusterfs.com': 'ClusterFS',
    'cosmosbay.com': 'Cosmosbay~Vectis',
    'dell.com': 'Dell',
    'devicescape.com': 'Devicescape',
    'elandigitalsystems.com': 'Elan Digital Systems',
    'Emulex.com': 'Emulex',
    'Emulex.Com': 'Emulex',
    'emulex.com': 'Emulex',
    'endrelia.com': 'Endrelia',
    'ericsson.com': 'Ericsson',
    'freescale.com': 'Freescale',
    'garzik.org': 'Red Hat',
    'google.com': 'Google',
    'hauppauge.com': 'Hauppauge',
    'hitachi.com': 'Hitachi',
    'hp.com': 'HP',
    'ibm.com': 'IBM',
    'icplus.com.tw': 'IC Plus',
    'ibp.de': 'ipb (uk) Ltd.',
    'intel.com': 'Intel',
    'jmicron.com': 'jmicron.com',
    'jp.fujitsu.com': 'Fujitsu',
    'kiethp.com': 'Intel',
    'linux-foundation.org': 'Linux Foundation',
    'lnxi.com': 'Linux Networx',
    'lsi.com': 'LSI Logic',
    'lsil.com': 'LSI Logic',
    'lwn.net': 'LWN.net',
    'mandriva.com.br': 'Mandriva',
    'microgate.com': 'MicroGate Systems',
    'myri.com': "Myricom",
    'mvista.com': 'MontaVista',
    'nec.com': 'NEC',
    'netxen.com': 'NetXen',
    'ntt.co.jp': 'NTT',
    'nvidia.com': 'NVidia',
    'opengridcomputing.com': 'Open Grid Computing',
    'oracle.com': 'Oracle',
    'pikron.com': 'PiKRON s.r.o',
    'promise.com': 'Promise Technology',
    'qumranet.com': 'Qumranet',
    'namesys.com': 'NameSys',
    'netapp.com': 'NetApp',
    'neterion.com': 'Neterion',
    'nokia.com': 'Nokia',
    'novell.com': 'Novell',
    'osdl.org': 'Linux Foundation',
    'ozlabs.org': 'IBM',
    'panasonic.com': 'Panasonic',
    'qlogic.com': 'QLogic',
    'redhat.com': 'Red Hat',
    'realtek.com.tw': 'Realtek',
    'renesas.com': 'Renesas Technology',
    'rockwell.com': 'Rockwell',
    'rowland.harvard.edu': 'Rowland Institute, Harvard',
    'samsung.com': 'Samsung',
    'sanpeople.com': 'SANPeople',
    'secretlab.ca': 'Secretlab',
    'sgi.com': 'SGI',
    'solidboot.com': 'Solid Boot Ltd.',
    'snapgear.com': "Snapgear",
    'sonycom.com': 'Sony',
    'sony.com': 'Sony',
    'st.com': 'ST Microelectronics',
    'SteelEye.com': 'SteelEye',
    'suse.de': 'Novell',
    'suse.cz': 'Novell',
    'suse.com': 'Novell',
    'tensilica.com': 'Tensilica',
    'ti.com': 'Texas Instruments',
    'toshiba.co.jp': 'Toshiba',
    'tresys.com': 'Tresys',
    'tripeaks.co.jp': 'Tripeaks',
    'TrustedCS.com': 'Trusted Computer Solutions',
    'tungstengraphics.com': 'Tungsten Graphics',
    'ubuntu.com': 'Canonical',
    'valinux.co.jp': 'VA Linux Systems Japan',
    'verismonetworks.com': 'Verismo',
    'veritas.com': 'Veritas',
    'via.com.tw': 'Via',
    'vmware.com': 'VMWare',
    'winbond.com': 'Winbond Electronics',
    'windriver.com': 'Wind River',
    'wipro.com': 'Wipro',
    'wolfsonmicro.com': 'Wolfson Microelectronics',
    'xensource.com': 'XenSource',
};

EmailToEmployer.update (PrivateMap.PrivateMap)


def MapAddr (email, unknown = 0):
    try:
        return EmailToEmployer[email]
    except KeyError:
        pass
    namedom = email.split ('@')
    if len (namedom) < 2:
        print 'Oops...funky email %s' % email
        return 'Funky'
    s = namedom[1].split ('.')
    for dots in range (len (s) - 2, -1, -1):
        addr = '.'.join (s[dots:])
        try:
            return EmailToEmployer[addr]
        except KeyError:
            pass
    if unknown:
        return '(Unknown)'
    return email


#
# Hack to get around multiple addresses used by some developers.
#
EmailAliases = {
    'akpm@osdl.org': 'akpm@linux-foundation.org',
    'alan@redhat.com': 'alan@lxorguk.ukuu.org.uk',
    'bzolnier@gmail.com': 'Bartlomiej.Zolnierkiewicz@gmail.com',
    'dbrownell@users.sourceforge.ent': 'david-b@pacbell.net',
    'jsipek@fsl.cs.sunysb.edu': 'jsipek@cs.sunysb.edu',
    'mel@csn.ul.ie': 'mel@skynet.ie',
    'nickpiggin@yahoo.com.au': 'npiggin@suse.de',
    'olof@lixom.net': 'olof@austin.ibm.com',
    'takata@linux-m32r.org': 'takata.hirokazu@renesas.com',
    'torvalds@osdl.org': 'torvalds@linux-foundation.org',
    'torvalds@woody.linux-foundation.org': 'torvalds@linux-foundation.org',
    }

def RemapEmail (email):
    try:
        return EmailAliases[email]
    except KeyError:
        return email
